//+------------------------------------------------------------------+
//|                                                  iAOfunc.mq4     |
//|                                         Author:  paladin80       |
//|                                         E-mail:  forevex@mail.ru |
//+------------------------------------------------------------------+
#property copyright "paladin80"
#property link      "forevex@mail.ru"
#property library
//--------------------------------------------- iAOfunc() - start ------------------------------------------------------------
//+----------------------------------------------------------------------------+
//| Input parameters:                                                          |
//|   Sy - Symbol.                                                             |
//|   Tf - Timeframe.                                                          |
//|   MA_mode - Applied MA method.                                             |
//|   Applied_price - Applied price.                                           |
//|   Period_1 , Period_2 - Periods for calculation of indicator               |
//|           (see formula below)                                              |
//|   Shift - Index of the value taken from the indicator buffer.              |
//+----------------------------------------------------------------------------+----+
//| Formula for calculation standsrd AO (http://codebase.mql4.com/251)              |
//|   The function iAOfunc() is calculated according formula:                       |
//|   AO = MA_mode (Applied_price, Period_1) - MA_mode (Applied_price, Period_2)    |
//+---------------------------------------------------------------------------------+
double iAOfunc(string Sy,int Tf,int MA_mode,int Applied_price,int Period_1,int Period_2,int Shift)
{
   double AO;
   if (Sy=="" || Sy=="0") Sy=Symbol();   
   AO=iMA(Sy,Tf,Period_1,0,MA_mode,Applied_price,Shift)-iMA(Sy,Tf,Period_2,0,MA_mode,Applied_price,Shift);
   return(AO);
}
//--------------------------------------------- iAOfunc() - end ------------------------------------------------------------

















